/*
   +----------------------------------------------------------------------+
   | Zend Engine                                                          |
   +----------------------------------------------------------------------+
   | Copyright (c) 2003 Sascha Schumann                                   |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.00 of the Zend license,     |
   | that is bundled with this package in the file LICENSE, and is        |
   | available at through the world-wide-web at                           |
   | http://www.zend.com/license/2_00.txt.                                |
   | If you did not receive a copy of the Zend license and are unable to  |
   | obtain it through the world-wide-web, please send a note to          |
   | license@zend.com so we can mail you a copy immediately.              |
   +----------------------------------------------------------------------+
   | Author: Sascha Schumann <sascha@schumann.cx>                         |
   +----------------------------------------------------------------------+
*/

/* for zend_bool and limits.h */
#include "zend.h"

#if defined(__i386__) && defined(__GNUC__)

#define ZEND_SIGNED_MULTIPLY_LONG(a, b, lval, dval, usedval) do {	\
	__asm__ ("imul %3,%0\n"											\
		"adc $0,%1" 												\
			: "=r"(lval),"=r"(usedval) 								\
			: "0"(a), "r"(b), "1"(0));								\
	if (usedval) (dval) = (double) (a) * (double) (b);				\
} while (0)

#else

#define ZEND_SIGNED_MULTIPLY_LONG(a, b, lval, dval, usedval) do {	\
	double __tmpvar = (double) (a) * (double) (b);					\
																	\
	if (__tmpvar >= LONG_MAX || __tmpvar <= LONG_MIN) {				\
		(dval) = __tmpvar;											\
		(usedval) = 1;												\
	} else {														\
		(lval) = (a) * (b);											\
		(usedval) = 0;												\
	}																\
} while (0)

#endif
